"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoadingPanelWrapped = exports.LoadingPanel = void 0;
const react_1 = __importStar(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const react_dom_1 = __importDefault(require("react-dom"));
require("./style.scss");
/* Ensure below is included in index.html */
const loadingRoot = document.getElementById('loading-root');
let loadingCount = 1;
const LoadingPanel = ({ open, message, collapsed, portalRootRef }) => {
    const [z] = (0, react_1.useState)(loadingCount);
    (0, react_1.useEffect)(() => {
        loadingCount += 1;
        return () => {
            loadingCount -= 1;
        };
    }, []);
    const classname = ['loadingPanel', collapsed ? 'collapsed' : '', open ? '' : 'hidden'].join(' ');
    return (portalRootRef === null || portalRootRef === void 0 ? void 0 : portalRootRef.current) ?
        react_dom_1.default.createPortal(react_1.default.createElement("div", { className: classname },
            react_1.default.createElement("div", null, open ? message : '')), portalRootRef.current) : react_1.default.createElement("div", null, "Loading");
};
exports.LoadingPanel = LoadingPanel;
exports.LoadingPanel.propTypes = {
    open: prop_types_1.default.bool,
    message: prop_types_1.default.string,
    collapsed: prop_types_1.default.bool,
    portalRootRef: prop_types_1.default.any,
};
exports.LoadingPanel.defaultProps = {
    open: false,
    message: 'Loading',
    collapsed: false,
    portalRootRef: { current: loadingRoot },
};
const LoadingPanelWrapped = ({ open, message, collapsed }) => {
    const portalRootRef = react_1.default.useRef(null);
    const [portalRootRefSt, setPortalRootRefSt] = (0, react_1.useState)();
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { ref: (current) => {
                portalRootRef.current = current;
                setPortalRootRefSt(portalRootRef.current);
            } }),
        react_1.default.createElement(exports.LoadingPanel, { open: open, message: message, collapsed: collapsed, portalRootRef: portalRootRef })));
};
exports.LoadingPanelWrapped = LoadingPanelWrapped;
//# sourceMappingURL=loading-panel.js.map